/*

Made by Darshan Shah
for Final Project of Melodic Resonance
at Fab Academy 2018,
Fab Lab UAE.

-----------------------------------------
*/


#include <SoftwareSerial.h>  // include serial library

#include <Adafruit_NeoPixel.h>  // include neopixel library
#ifdef __AVR__                  // define AVR
#include <avr/power.h>          // define AVR power
#endif
#define rxPin 0                 // define reciever pin
#define txPin 1                 // define transmittor pin
#define PIN 8                   // define the pin for Neopixel LEDs

int analogInPin = 3;  // Analog input pin that the mic is attached to

int val;              // integer value for the mic
Adafruit_NeoPixel strip = Adafruit_NeoPixel(13, PIN, NEO_GRB + NEO_KHZ800);  // define the no. of pixels, tyoe and power

SoftwareSerial serial(rxPin, txPin);  // set up communication 
void setup()  {
  pinMode(rxPin, INPUT_PULLUP);       // define pinmode reciever for input
  pinMode(txPin, OUTPUT);             // define pinmode transmittor for output
  serial.begin(9600);                 // begin communication at 9600 bytes per seconf
  strip.begin();                      // begin the neopixel strip connection
  
    strip.show();                    // Intitializind LEDs off for the start of the test
}

void loop() {
  val = analogRead(analogInPin);     // read the input pin
  serial.println(val);             // debug value
  if((val>=0)&&(val<=100)){         // rangle of values of input
    //colorWipe(strip.Color(255, 0, 255), 20);     
    colorWipe(strip.Color(0,0,0),20);       // color patter n for no color through color code
  }
    //else {
    //colorWipe(strip.Color(0, 255, 0), 20);}
  if((val>=101)&&(val<=190)){        // range of values of input
    colorShow(4,strip.Color(255,0,0),20);   // show red color on 0,1,2,3 number of neopixels
    delay(20);                             // delay at 0.02 seconds
  }  
  if((val>=191)&& (val<=300)){             // range of values
    //colorWipe(strip.Color(0,0,0),20);     
    colorShow(7,strip.Color(0,255,0),20);   // show green color for 0-6 number of neopixels
    delay(20);
  } 
   if((val>=200)){                         // range of values for input
    //colorWipe(strip.Color(0,0,0),20);
    colorShow(13,strip.Color(0,0,255),20);  // show blue color for 0-12 number of neopixels
    delay(20);
  }
    }


// command and functions of different patterns for the neopxel LEDs 

// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    delay(wait);
    strip.show();
  }
}
  void colorShow(int n, uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<n; i++) {
    strip.setPixelColor(i, c);
    //serial.print(i);
    //serial.println("       This is the number of LOOOPSSs");
    delay(wait);
    
      strip.show();
    }
  }
void changeColor(uint32_t c) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
  }
  strip.show();
}  
void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}  
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}
// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);

}
